using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Engine.Forms
{
    public partial class BehaviorSetter : Form
    {
        public IBehaviorCharacterization bc = null;
        List<string> functions = new List<string>();
        public BehaviorSetter()
        {
            InitializeComponent();
        }

        public void setup(string behavior)
        {
            foreach (Type t in this.GetType().Assembly.GetTypes())
            {
                if (t.GetInterface("IBehaviorCharacterization", true) != null)
                    functionComboBox.Items.Add(t.Name);
            }

            bc = BehaviorCharacterizationFactory.getBehaviorCharacterization(behavior);
            if (bc != null)
            {
                for (int j = 0; j < functionComboBox.Items.Count; j++)
                    if (functionComboBox.Items[j].ToString().Equals(bc.name))
                    {
                        functionComboBox.SelectedIndex = j;
                        break;
                    }
            }
            fillTextBox2();
        }

        private void fillTextBox2()
        {
            if (bc != null)
                textBox2.Text = bc.description;
            else
                textBox2.Text = "Not Found.";
            textBox2.Invalidate();
        }

        private void functionComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            bc = BehaviorCharacterizationFactory.getBehaviorCharacterization(functionComboBox.SelectedItem.ToString());
            fillTextBox2();
            Invalidate();
        }
    }
}
