﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Engine.Forms
{
    public partial class FitnessFunctionSetter : Form
    {
        public IFitnessFunction fitFun = null;
        List<string> functions = new List<string>();
        public FitnessFunctionSetter()
        {
            InitializeComponent();
        }

        public void setup(string fitnessFunction)
        {
            foreach (Type t in this.GetType().Assembly.GetTypes())
            {
                if (t.GetInterface("IFitnessFunction", true) != null)
                    functionComboBox.Items.Add(t.Name);
            }

            fitFun = FitnessFunctionFactory.getFitnessFunction(fitnessFunction);
            if (fitFun != null)
            {
                for (int j = 0; j < functionComboBox.Items.Count; j++)
                    if (functionComboBox.Items[j].ToString().Equals(fitFun.name))
                    {
                        functionComboBox.SelectedIndex = j;
                        break;
                    }
            }
            fillTextBox2();
        }

        private void fillTextBox2()
        {
            if (fitFun != null)
                textBox2.Text = fitFun.description;
            else
                textBox2.Text = "Not Found.";
            textBox2.Invalidate();
        }

        private void functionComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            fitFun = FitnessFunctionFactory.getFitnessFunction(functionComboBox.SelectedItem.ToString());
            fillTextBox2();
            Invalidate();
        }
    }
}
